*H SCPELK.S
; AUTOR:Lutz Elssner
; STAND:07.04.89
; ------------------
; CCP residente Kommandos DIR,ERA,TYPE,SAVE,REN,USER,EXT,RES,SWAP,HELP
; ====================================================================
;
;; Behandlung  "DIR [<File mit *>]"
;  ================================
	
ICBED:	CALL	FNHOL		;Filenamen holen
	CALL	ICB26		;Select Disk
	LD	HL,CFCBF	;Filename
	LD	A,(HL)
	CP	' '		;angegeben?
	JR	NZ,ICC02	;ja
	LD	B,11		;sonst ????????.???
ICBFD:	LD	(HL),'?'
	INC	HL
	DJNZ	ICBFD
ICC02:	CALL	IC8DD		;suchen erstes passendes File
	JP	Z,IC8A8		;NO FILE, fertig
	LD	D,255		;D zaehlt ausgeb. Files
	PUSH	DE
ICC0B:	DEC	A		;Dir Entry 0..3 von Search/Next
	RRCA
	RRCA
	RRCA
	AND	60H		;*32
	LD	HL,DEFDMA
	ADD	A,L
	LD	L,A		;HL:= ^Dir-Eintrag
	PUSH	HL
	POP	IX
	BIT	7,(IX+10)	;SYS-Atribut?
	JR	NZ,ICC59	;ja, uebergehen
	POP	AF		;ausgegebene Filenamen
	INC	A		;zaehlen mod 4
	AND	03H		;4. File in Zeile?
	PUSH	AF
	LD	A,' '
	JR	NZ,ICC35	;nein
	CALL	NEWLN		;sonst CR,LF
	LD	A,(SELDAK)	;aktuell selektiertes LW
	ADD	A,'A'
ICC35:	CALL	PUTCH
	LD	A,':'
	CALL	PUTCH
	CALL	IC88F
	LD	BC,0802H	;8 Zeichen Filename, danach Ext.
ICC43:	INC	IX
	LD	A,(IX)		;Filenamenzeichen
	AND	7FH		;ohne Bit 7
	CALL	PUTCH
	DJNZ	ICC43
	DEC	C
	JR	Z,ICC59
	CALL	IC88F
	LD	B,3		;Typ 3 Zeichen
	JR	ICC43
;
ICC59:	CALL	IC8FB		;Taste gedrueckt?
	JP	NZ,ENDKB	;ja, Abbruch
	CALL	IC8E4		;sonst naechstes File suchen
	JR	NZ,ICC0B	;gefunden
ICC63:	JP	ENDKB		;Ende residentes Kommando
;
;; Behandlung "ERA <File mit *>"
;  =============================
	
ICC66:	CALL	FNHOL		;Filenamen holen
	CP	11		;*.* ?
	JR	NZ,ICC84	;nein
	LD	BC,DCC93	;ALL (Y/N)?
	CALL	IC8AB
	CALL	IC92D		;Antwort (als Kommando!)
	LD	HL,COMBL2	;Anzahl der Zeichen
	DEC	(HL)		;-1 ?
	RET	NZ		;nein
	INC	HL
	LD	A,(HL)		;Antwort
	CP	'Y'		;Y?
	RET	NZ		;nein
	INC	HL
	LD	(COMPP2),HL
ICC84:	CALL	ICB26		;Select Disk
	CALL	DELETF		;Delete
	INC	A		;A=FF
	CALL	Z,IC8A8		;ja, NO FILE
	JP	ENDKB		;fertig
*EJEC
	
;; Behandlung "TYPE <File>"
;  ========================
	
ICC9E:	CALL	FNHOL		;Filenamen holen
	JR	NZ,ICCE4	;enthaelt */?
	CALL	ICB26		;Select Disk
	CALL	IC8C8		;Open
	JR	Z,ICCE1		;nicht da
	CALL	NEWLN		;CR, LF
	LD	BC,80H		;Zeiger in DMA
ICCB3:	LD	A,C
	CP	80H		;alle Zeichen in DMA benutzt?
	JR	C,ICCC4		;nein
	CALL	IC8ED		;read
	JR	NZ,ICCDA	;Fehler oder EOF
	LD	BC,0
ICCC4:	LD	HL,DEFDMA
	ADD	HL,BC
	LD	A,(HL)		;naechstes Zeichen
	CP	1AH		;Fileende?
	JR	Z,ICCDB		;ja
	PUSH	BC
	CALL	PUTCH		;sonst ausgeben
	CALL	IC8FB		;Taste gedrueckt?
	POP	BC
	JP	NZ,ENDKB	;ja, Abbruch
	INC	BC
	JR	ICCB3
	
ICCDA:	DEC	A		;EOF?
ICCDB:	JP	Z,ENDKB		;ja
	CALL	RDERR		;READ ERROR
ICCE1:
ICCE4:	JP	ICF1B		;Fehler, Param. prot.
*EJEC
	
;; Behandlung "SAVE <256er Bloecke> <File>"
;  ========================================
	
ICCE7:	CALL	ICAE9		;Zahl holen
	JR	C,SAVEXT	;keine Zahl --> SAVE EXT Kommando
	PUSH	AF
	CALL	FNHOL		;File holen
	JP	NZ,ICF1B	;nicht eindeutig
; ******
	CALL	SAVEUP
;CALL	ICB26		;Select Disk
;CALL	MAKEF		;Make
;JR	Z,ICD2F		;kein Platz
;XOR	A
;LD	(CFCBCR),A	;aktueller Record :=0
	LD	H,A
	POP	AF
	LD	L,A
	ADD	HL,HL		;hl:= Anzahl der Records
	LD	DE,TPA
ICD0C:	LD	A,H
	OR	L		;fertig?
	JR	Z,ICD26		;ja
	DEC	HL
	PUSH	HL		;merken Restanzahl
	LD	HL,0080H
	ADD	HL,DE
	PUSH	HL		;merken naechstes DMA
	CALL	SETDMA		;Set DMA
	CALL	IC8F7		;write
	POP	DE
	POP	HL
	JR	NZ,ICD2F	;Fehler
	JR	ICD0C
	
ICD26:	CALL	CLOSEF		;Close
	INC	A		;ok?
	JR	NZ,ICD35	;ja
ICD2F:	CALL	NOSPC		;No Space
ICD35:	JP	ENDKB		;Komm.ende
; ===============================
SAVEUP:	CALL	ICB26		;Select Disk
	CALL	MAKEF		;Make
	JR	Z,ICD2F		;kein Platz
	XOR	A
	LD	(CFCBCR),A	;aktueller Record :=0
	RET
; ===============================
; Programmteil fuer SAVE der EXT-Kommandos
SAVEXT:	CALL	FNHOL		;Filename von Parameterzeile in FCB
	JP	NZ,ICF1B	;nicht eindeutig
	CALL	RSUCH		;suchen des Dateinamens in Tabelle
	JP	C,ICF1B	 	;im ROM gefunden oder nicht gefunden
	LD	L,C		;BC=Adresse des vorhergehenden
	LD	H,B		;EXT Kommandos bzw.TREND
	OR	A		;CY=0
	SBC	HL,DE
	PUSH	DE		;DE=Anfangsadresse
	PUSH	HL		;HL=Laenge in Bytes (Vielfaches von 80H)
	CALL	SAVEUP		;Datei anlegen
	POP	HL		;HL/128
;
	RL	L		;CY <-- L <-- CY
	LD	L,H		;
	RL	L
	LD	H,0
	RL	H
;
	POP	DE
	JR	ICD0C
*EJEC
	
;; Behandlung "REN <neues File>=<altes File>"
;  ==========================================
	
ICD44:	CALL	FNHOL		;Filenamen holen
	JR	NZ,ICDA3	;Fehler, enth. *
	LD	A,(DCF6E)	;expl. LW merken
	PUSH	AF
	CALL	ICB26		;Select Disk
	CALL	IC8DD		;Search for first
	JR	NZ,ICDA6	;File exists
	LD	HL,CFCBD	;sonst neuen Filenamen als 2.
	LD	DE,CFCB0
	LD	BC,0010H
	LDIR
	LD	HL,(COMPP2)
	EX	DE,HL
	CALL	IC9D4		;naechstes Zeichen <> ' '
	CP	'='
	JR	Z,ICD70
	CP	'_'
	JR	NZ,ICDA0
ICD70:	EX	DE,HL
	INC	HL
	LD	(COMPP2),HL
	CALL	FNHOL		;zweiten Filenamen
	JR	NZ,ICDA0	;enthaelt *
	POP	BC		;gemerktes expl. LW
	LD	HL,DCF6E	;zweites expl. LW
	LD	A,(HL)
	OR	A		;angegeben?
	JR	Z,ICD86		;nein
	CP	B		;gleich erstem?
	LD	(HL),B
	JR	NZ,ICDA0	;nein
ICD86:	LD	(HL),B
	XOR	A
	LD	(CFCB0),A	;Standard-LW in FCB
	CALL	IC8DD		;Search for first
	JR	Z,ICD9B		;File nicht da
	CALL	RENAMF
ICD98:	JP	ENDKB		;Kommando-Ende
	
ICD9B:	CALL	IC8A8		;NO FILE
	JR	ICD98
	
ICDA0:
ICDA3:	JP	ICF1B		;Fehler
	
ICDA6:	CALL	FILEX		;File exists
	JR	ICD98
*EJEC
	
;; Behandlung "USER <Nutzernummer 0..15>"
;  ======================================
	
ICDBA:	CALL	ICAE9		;Zahl holen
	JP	C,ICF1B	 	;Fehler, Rest prot.
	CP	16		;>=16?
	JR	NC,ICDA3	;ja
	LD	(DEFUS),A
	RET
	
	
;; Behandlung "EXT <COM-File>"
;  ===========================
;
EXT:	CALL	FNHOL		;Filenamen holen
	JP	NZ,ICF1B	;Fehler, enthaelt '?'
;
	COND	LRESC<8	 	;bei Laenge 8 kann Name nicht zu lang sein
	LD	A,(CFCBF+LRESC)	;Filename < LRESC+1 Zeichen?
	CP	' '
	JR	NZ,ICF1B	;nein
	ENDC
;
	CALL	RSUCH		;residentes Kommando in Tabelle suchen
	JP	NZ,FILEX	;File exists
;
	LD	HL,ENDX2-2	;(HL)=letztes Byte des letzten Eintrages
	SBC	HL,DE		;noch Platz in Tabelle?
	JP	C,NOSPC		;No Space
;File ab TPA von Diskette laden
	PUSH	DE		;(DE)=0 altes Tabellenendekennzeichen
	CALL	LODCOM		;File laden
	POP	DE
;Filename von FCB in Tabelle der residenten Kommandos uebertragen
	LD	HL,CFCBF	;Filename
				;(DE)=0 altes Tabellenendekennzeichen
	LD	BC,LRESC
	LDIR			;LRESC Zeichen in Tabelle
;neuer Wert fuer EXT-Zeiger (EXTZ)=(EXTZ)-(LFILE)
	LD	HL,(EXTZ)	;alt
	XOR	A
	LD	BC,(LFILE)	;Laenge des geladenen Files, Vielfaches von 80H
	SBC	HL,BC
	LD	(EXTZ),HL	;neu
;Fileanfangsadresse und Endekennzeichen in Tabelle der residenten Kommandos
	EX	DE,HL
	LD	(HL),E		;Routinenadr. in Tabelle
	INC	HL
	LD	(HL),D
	INC	HL
	LD	(HL),A		;neues Tabellenende
;wenn Laenge des geladenen Files=0, dann Kommandoende
	LD	A,C
	OR	B
	RET	Z
;aktuelle Fehleradressen von (BDOSAD)+3 in (TREND)+3 retten
	PUSH	DE
	PUSH	BC
	CALL	RESFE		;Teilprogramm von RES
	POP	BC		;LFILE
	POP	HL		;EXTZ
;File Verschiebung an das TPA-Ende
	ADD	HL,BC
	DEC	HL
	EX	DE,HL		;DE = EXTZ + LFILE - 1 (Endadresse Ziel)
;
	LD	HL,TPA
	ADD	HL,BC
	DEC	HL		;HL = TPA + LFILE - 1 (Endadresse Quelle)
;
	CALL	LDDRU		;Verschiebung im RAM BC = LFILE
;Errechnen Laenge Vorspann
	LD	BC,LVOR
;Vorspann von (TREND) vor Programm (EXTZ)-LVOR
	LD	HL,(EXTZ)
	OR	A
	SBC	HL,BC
	PUSH	HL		;das wird neue BDOS-Sprungadresse
	EX	DE,HL		;DE=(EXTZ)-LVOR (Anfangsadresse Ziel)
	LD	HL,(TREND)	;HL=(TREND)     (Anfangsadresse Quelle)
	CALL	LDIRU
;BDOS-Sprungbefehl neu belegen
	POP	DE
	LD	(CBDOS),DE	;fuer Regenerierung bei Warmstart
	LD	(BDOSAD),DE	;neue BDOS-Adresse
;eigenene Fehlerbehandlungsroutinen mit aktuellen Adressen komplett
;in RAM schreiben
	INC	DE		;uebergehen Sprungbefehl zum BDOS im neuen Vorspann
	INC	DE
	INC	DE		;DE=Standort der 1.Adresse
	LD	HL,ESEC2	;HL=Beginn der 1.Fehlerbehandlungsroutine
	LD	B,4		;B =Anzahl der Routinen
EXT1:	LD	(HL),2AH	;Code von LD HL,(nn)
	INC	HL
	LD	(HL),E		;Adresse L
	INC	HL
	LD	(HL),D		;Adresse H
	INC	HL
	LD	(HL),0E9H	;Code von JP (HL)
	INC	HL
;
	INC	DE		;Uebergang zur naechsten Adresse
	INC	DE
	DJNZ	EXT1
;eigene Fehlerbehandlungsroutinenadressen in Vorspann (TREND)+3
	LD	HL,ETAB2
	LD	DE,(TREND)
	INC	DE		;Uebergehen Sprungbefehl zum BDOS
	INC	DE
	INC	DE
	LD	BC,8
	JP	LDIRU
*EJEC
;--------------------------------
;
;; Behandlung "RES"
;  ================
	
RES:	LD	HL,(TREND)	;EXT-Zeiger zurueck
	LD	(EXTZ),HL
	LD	(CBDOS),HL	;fuer Regenerierung bei Warmstart
	XOR	A
	LD	(RESX2),A	;Endekennzeichen in Tabelle der res. Kommandos
;Aufruf von EXT zum Zwischenspeichern der Fehleradressen
RESFE:	LD	HL,(TREND)
	LD	DE,(BDOSAD)
	LD	(BDOSAD),HL
;
	OR	A
	PUSH	HL
	SBC	HL,DE
	POP	HL
	RET	Z		;(TREND)=(BDOSAD) kein EXT-Kommando nachgeladen
;
	LD	BC,3
	ADD	HL,BC
	EX	DE,HL		;Transport der Fehleradressen
	ADD	HL,BC		;von (BDOSAD)+3 nach (TREND)+3
	LD	BC,8
	JP	LDIRU
*EJEC
	
;; Behandlung "SWAP <Laufwerk>: <Laufwerk>:"
;  =========================================
	
SWAP:	CALL	FNHOL		;holen LW1
	CALL	DSKSEL		;HL auf DPH
	PUSH	HL		;merken DPH1
	CALL	FNHOL		;holen LW2
	CALL	DSKSEL		;HL auf DPH
	POP	DE		;DE auf DPH1
	LD	B,10H		;Laenge eines DPH
SWAPZ:	LD	A,(DE)
	LD	C,(HL)
	LD	(HL),A
	LD	A,C
	LD	(DE),A
	INC	DE
	INC	HL
	DJNZ	SWAPZ
; ( Neuuebernahme der DPH's durch Warmstart erzwingen )
	JP	0
;
	
DSKSEL:	LD	A,(DEFFCB)	;Laufwerk aus FCB
	DEC	A		;A => 0, ...
	LD	C,A
	LD	E,0		;LOGIN
	CALL	ISELDSK		;seldsk ueber BIOS
	LD	A,H		;ex. DPH?
	OR	L
	RET	NZ		;ja
	JP	ICF1B		;nein, Parameterfehler
	
	
;; Behandlung "HELP"
;  =================
HELP:	LD	HL,RESCI	;interne Kommandotabelle im ROM
	LD	B,LRESO	 	;Filenamenlaenge im ROM
	CALL	HELPZ
;
	LD	HL,RESC2	;externe Kommandotabelle im RAM
	LD	B,LRESC	 	;Filenamenlaenge im RAM
;
HELPZ:	PUSH	BC
	PUSH	HL
	CALL	NEWLN		;CR,LF
	POP	HL
	POP	BC
;
	LD	A,(HL)
	OR	A		;Tab.ende?
	RET	Z		;ja
;
	PUSH	BC
HELPZ1:	LD	A,(HL)
	PUSH	BC
	PUSH	HL
	CALL	PUTCH
	POP	HL
	INC	HL
	POP	BC
	DJNZ	HELPZ1
	POP	BC
	INC	HL
	INC	HL
	JR	HELPZ
; ===============================
; ENDE SCPELK.S
; ===============================
