*H SCPLOE.S
;*************************************************
;SCP-Kaltstart/ROM-Teil
;----------------------
;Date: 10.04.89
;*************************************************
;
 EXTERNAL	INISCR	INIBIOS STINI	SFLINI
;
CBOOT:
	DI
	LD	A,3
	LD	(BSKENN),A	;SCP-Kennzeichen
	CALL	COPTRA		;BIOS-Treibertabellen u. Progr. in RAM
	CALL	INIBIOS
	CALL	INISCR		;Screen-Loeschen
	CALL	STINI		;Statuszeile init
	CALL	INITST		;Tastatur-Init.
	CALL	INIV24		;V24 und Drucker-Init. (SCPELV.S)
	CALL	SFLINI		;Floppy init (nach STINI u. INITST !)
	CALL	INITSB		;SCP-BDOS-Anlauf
;
	LD	A,(SLCTRL)	;RAM Page0/Slot 2 einschalten
	AND	0FCH
	OR	02H
	OUT	(PPIA),A
;
	LD	BC,8		;WBOOT/Kaltst.-LW/IO-BYTE/TPA
	LD	DE,00H          ;ab Adr. 0 eintragen
	LD	HL,CB0
	LDIR
;
	LD	A,'$'
	PUSH	AF
	LD	HL,CBMSG0-1	;Kaltstartmeldung
	CALL	CB00
	LD	HL,Vors0+4	;Versionsnr. aus BDOS-Vorspann
	PUSH	HL
	CALL	CB02
	LD	C,'.'
	CALL	ICONOUT
	POP	HL
	DEC	HL
	CALL	CB02
	POP	AF
	LD	HL,CBMSG1-1
	CALL	CB00
;
	LD	A,(SLCTRL)
	OUT	(PPIA),A	;Bankbelegung auf Anfangsbelegung
	EI
	JP	KW1BOOT		;JMP zum verkuerzten Warmstart
;--------------------------------
CB00:	INC	HL
	LD	C,(HL)
	CP	C
	RET	Z
	PUSH 	AF
	PUSH	HL
	CALL	ICONOUT		;BIOS-Ruf CONOUT, C: auszugebendes Z.
	POP	HL
	POP	AF
	JR	CB00
;
CB02:	LD	A,(HL)
	AND	0F0H
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	ADD	A,30H
	LD	C,A
	PUSH	HL
	CALL	ICONOUT
	POP	HL
	LD	A,(HL)
	AND	0FH
	ADD	A,30H
	LD	C,A
	CALL	ICONOUT
	RET
;	-------------------------
CB0:	JP	IWBOOT		;Wboot-Adr.in Sprungleiste
	DEFB	95H		;IO-Byte
	DEFB	0		;User 0/Drive A
	JP	SBDOS		;TPA-Adr.(RAM-Adr.!)/JMP zu Bankumsch.
				;dort JMP zum BDOS im ROM
;
CBMSG0:	
	DEFW	0D0AH
	DEFW	0D0AH
	DEFM	'ROBOTRON A 5105'
	DEFW	0D0AH
	DEFM	'SCP VERS. '
	DEFB	'$'
CBMSG1:	DEFW	0D0AH
	DEFB	'$'
;
;------------------------------
