;*****************************************
; Daten fuer FD-Modul			 *
;*****************************************
;file:	FDDAT1.S
;date:	02.05.89
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Interne Schnittstelle (ACHTUNG: ab IX+12 anders als die v.Block.-Modul) fuer:
;~~~~~~~		    	;Lesen / Schreiben		I Formatieren
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
SCHN:	DEFS	1	;  0    :KOMMANDO (RD,WR,..)	(ix)   	I
LAUFW:	DEFS	1	;  1	:LAUFWERK		(ix+1)	I
SPUR:	DEFS	1	;  2	:SPUR			(ix+2)	I
KOPF:	DEFS	1	;  3	:KOPF			(ix+3)	I
SKT1:	DEFS	1	;  4	:SEKTOR			(ix+4)  I  Sektorinhalt
DFLDL:	DEFS	1	;  5	:rel.DATENFELDLAENGE   	(ix+5)	I
GAP:	DEFS	1	;  6	:LUECKE (GAP 3)       	(ix+6)  I  Luecke 3
SANZL:	DEFS	1	;  7	:SEKTORANZAHL		(ix+7)	I
VERF:	DEFS	1	;  8	:VERFAHREN (FM/MFM)	(ix+8)	I
SPUD:	DEFS	1	;  9	:SCHRITTE/SPUR		(ix+9)	I
PUFFL:	DEFS	1	; 10	:PUFFERADRESSE (LOW)	(ix+10)	I
PUFFH:	DEFS	1 	; 11	:PUFFERADRESSE (HIGH)	(ix+11)	I
;
;--------------------------------
;
DRPB:	DEFS	1	; 12	:LW-Typ MFS 1.6
	DEFS	1	; 13	:1.Spur m.Praekomp.
	DEFS	1	; 14	:Schrittzeit SRT = 4 ms ( 4 MHz-FDC !!)
	DEFS	1	; 15	:Kopfberuhigungszeit n.Andruck HLT = 4 ms
			;	  Obwohl Kopf d.Hebel stat.angedr.w.,muss HLT > 0,
			;	  d.h. Byte 15 > 0 sein (Wert 0 ==> max.HLT = 508ms)
	DEFS	1	; 16	:dto.nach Step SPA = 10 ms (lt.LOGI 8,8 ms!)
	DEFS	1	; 17	:1.Spur m.Schreibstrombegrenzg.
	DEFS	1	; 18	:Option f.Kontrollesen (B3=0: mit Kontr.RD)
	DEFS	1	; 19	:Kopfentladezeit HUT (32ms-Schritte)
	DEFS	1	; 20	:Praekomp.zeit
	DEFS	1	; 21	:frei
;
;Tabellen fuer FDC - Befehle
;---------------------------
SPEZT:	DEFS 1		;Spezifizierung des FDC U8272 (4 MHz-Version)
K1SPEZ:	DEFS 1		;Kommando
K2SPEZ:	DEFS 1		;SRT / HUT = 6/32 ms = d0(F=2ms,E=4ms,..) + 01(32ms) = d1h
K3SPEZ:	DEFS 1		;HLT / ND  = 4 ms/01 = 02h(1*4ms) + Nicht-DMA (01h)  = 03h
HOMET:	DEFS 1		;HOME
	DEFS 1		;Kommando
	DEFS 1		;LW
SEEKT:	DEFS 1		;SEEK
	DEFS 1		;Kommando
	DEFS 1		;LW / Kopf
	DEFS 1		;NCN (Spur)
SENSET:	DEFS 1		;SENSE
	DEFS 1		;Kommando
IDLEST:	DEFS 1		;LESE ID
	DEFS 1		;Kommando
	DEFS 1		;LW / Kopf
	
STATT:	DEFS 1		;LW - STATUS
	DEFS 1		;Kommando
	DEFS 1		;LW / Kopf
;
;Komm.-Tab f.RD/WR/FORMAT/SCAN-Op.
;---------------------------------
CODET:	DEFS	1	;Laenge der Code-Tab.f.RD/WR-Op.
K1CODE: DEFS	1	;Kommando		FORMATIEREN
K2CODE:	DEFS	1	;LW/Kopf		-----------
KSINFO:	DEFS	1	;Spur			Bytes/Sektor
	DEFS	1	;Kopf			Sektoren/Spur
	DEFS	1	;Sektor			Luecke 3
KN:	DEFS	1	;Byte/Sektor		Datenbyte
KEOT:	DEFS	1	;End of	Track
KGPL:	DEFS	1	;Gap 3
KDTL:	DEFS	1	;128
;------------------------------------
RSTAT:	DEFS	1	;Status-Reg.
			;Aufbau von rstat (Statusregister 3)
			;  BIT  7	fault write
			;	6	write protect
			;	5	ready
                        ;       4	track 0
                       	;	3	side-signal
                       	;	2	head-adresse
                       	;	1/0	drive
;
SEEKST:	DEFS	1	;Status f.SEEK (PCN muss folgen!)
PCN:	DEFS	1	;momentane Spur-Nr.
NCN:	DEFS	1	;next Spur-Nr.FDC
STATB:	DEFS	1
AISSP:	DEFS	2	;Adr.f.akt.ISSP0
ISSP0:	DEFS	1	;Istspur LW 0
ISSP1:	DEFS	1	;LW1
ISSP2:	DEFS	1	;LW2
ZRES:	DEFS	1	;Zaehler f.Resultatbytes
IDF:	DEFS	7	;ID-Feld
HOMEZ:	DEFS	1	;nicht mehr als drei aut.HOME n.geles.ID-Feld.Bei Vers.
			;OHNE vorh.ID-Feldlesen b.Sec-Arbeit ist im F.-Fall home
			;unwirksam,wenn log.ISTsp.in Var.PCN = SOLLsp.in (IX+2),
			;Kopf aber falsch steht (z.B.sogar ausserh.Spurber./Disk)
HOMEZ1:	DEFS	1	;falls FDC ausserhalb Spurber.,dann nach lesz-mal vergebl.
			;Sec-RD/WR-Versuch nochmal wiederh.m.Spur0-Anf.entspr.homez1
			;(bei SecRD/WR-Op.ohne vorh.ID-Feldlesen w.homez n.wirksam)
HOMEZ2:	DEFS	1	;HOME-Zaehler f.Real.HOME nach fehlerh.Kontrolllesen eines Sec
LESZ:	DEFS	1	;Leseversuche
SCANZ:	DEFS	1	;Pruef-Leseversuche
RESULT:	DEFS	7	;7 Resultatsbytes
SKTGR:	DEFS	2
BLCKL:	DEFS	2
ZREGSP:	DEFS	1	;Zw.-Speicher f.SW/ZREG m.akt.Motorcode + Praekomp.bit
FREI2:	DEFS	1
IX00:	DEFS	2	;Zelle f.IX
SP00:	DEFS	2
DE000:	DEFS	2
XXX:	DEFS	2
YYY:	DEFS	2
;
;******************************************************************************
