;**********************************************************************
;Erweiterung fuer extern Geraete
;Einbindung fuer K87-Lesetreiber
;20.3.1989
;Kommandos: OPEN - INPUT# - CLOSE
;**********************************************************************
;
;ab Marke FCB0 + 9 vorhandener 100h RAM-Bereich wird teilweise benutzt
;
;FCB0+9 :Adr. fuer naechstes Zeichen (PTR)
;FCB0+11: Anzahl noch vorhandener Zeichen im Buffer
;FCB0+12: LBLNR, Nr. des zulesenden Blockes
;FCB0+13: BLNR, Nr. des gelesenen Blockes
;FCB0+14: 128 Byte Kassettenbuffer
;====================================================
RSOLO	EQU	0
DSE	equ	0
DSE1RA	equ	0
DSE2RA	equ	0
;Einfuegen ORG.S
;	   BICRAM.S
*L OFF
*I 3/ORG.S
*I 3/BICRAM.S
*L ON
PPIA	equ	0a8h
PPIM	equ	0abh
DPIOB	equ	91h
;
	external	ERRO
	external	CLOSE1
JL1CAL	equ	159h
MOTST	equ	0F3h
DSTPTS	equ	0b7h
RDRIPU	equ	9fh
;-----------------------------------
;
	org	4000h
;
	defm	'AB'	;Kennz. Erweiterung
	defw	0	;kein Init
	defw	0	;kein Call
	defw	EXTGER	;Aufruf ext. Ger.
	defw	0	;kein Zusatz-RAM
	defw	0
	defw	0
	defw	0
;-------------------Tabelle externer Geraete----
TBXGER	defm	'K87'
	defb	80h	;Kennz. 0
	defb	0	;Tabellenende
;-------------------Tab. Adresztabellen ext. Ger.
TBXGAD	defw	TABK87
;-------------------Tabelle fuer K87-------------
TABK87	defw	K870	;OPEN
	defw	K872	;CLOSE
	defw	ERRFC	;PUT/GET
	defw	ERRFC	;PRINT#
	defw	K878	;INPUT#
	defw	ERRFC	;LOC
	defw	ERRFC	;LOF
	defw	ERRFC	;EOF
	defw	ERRFC	;FPOS
	defw	ERRFC	;LINE INPUT#
;------------------Verteiler fuer ext. Geraete--
EXTGER	and	a
	jp	m,EXTGE0	;a=FF -> Namen suchen
	cp	14h	;Opcode zulaessig ?
	jr	nc,ERRFC	;nein (0,2,...,12)
	push	hl	;fcb-Adr.
	push	de	;e: file type
	push	af	;a: opcode
	ld	a,(HLPBNK)	;Geraetekennzeichen
	sla	a
	ld	c,a
	ld	b,0
	ld	hl,TBXGAD	;Tabelle Adresztab.
	add	hl,bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)	;de: Geraetetab.
	pop	af	;Opcode
	ld	l,a
	ld	h,0
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl	;hl: Startadr. Routine
	pop	de	;e: file type
	ex	(sp),hl	 ;fcb-Adr.
	ret		;Absprung dorthin
;-----------------------------------------------
K870	ld	a,e	;OPEN fuer K87
	cp	1	;input-file ?
	jr	nz,ERRBFN	;nein
	push	de
	push	hl
	call	LUE0	;Block 1 lesen, Namen vergleichen
	pop	hl
	pop	de
	ld	(ACTFCB),hl	;ACTFCB setzen
	ld	(hl),e	;mode eintragen
	ret
;**********************************************
;
K872	ld	a,(hl)	;CLOSE fuer K87
	cp	1	;mode = input ?
	jr	nz,ERRBFN
	xor	a
	call	MOTST	;Motor aus
	xor	a
	ret
;**********************************************
;
K878	ld	a,(hl)	;INPUT#
	cp	1	;mode = input ?
	jr	nz,ERRBFN
	call	LUE1	;Zeichen lesen
	ret	;mit Pufferung u. Endetest
;*********************************************
;
ERRBFN	ld	e,38h	;bad file name
	defb	1
ERRFC	ld	e,5	;ill. function call
	ld	bc,0
	xor	a
	call	MOTST	;Motor aus
	xor	a
	ld	(LMAFL),a
	ld	(HLPERR),a
	ld	hl,0
	ld	(ACTFCB),hl
	push	de
	ld	ix,CLOSE1	;alle fles schliessen
	call	JL1CAL
	pop	de
	ld	ix,ERRO
	jp	JL1CAL
;
EXTGE0	ld	hl,TBXGER	;Namen suchen in TBXGER
EXTGE3	ld	de,NACALL	;Namen in NACALL	
	ld	b,3	Laenge max. 3
EXTGE2	ld	a,(de)
	cp	(hl)
	jr	nz,EXTGE1	;Namen <>
	inc	hl
	inc	de
	djnz	EXTGE2
	ld	a,(hl)	;Namen =
	and	3	;a: Geraetekennzeichen
	ret
;
EXTGE1	inc	hl
	djnz	EXTGE1	;naechsten Namen
	ld	a,(hl)
	and	a	;Tabellenende ?
	inc	hl
	jp	m,EXTGE3	;nein, weitersuchen
	scf		;ja, Namen nicht gefunden
	ret
;----------------------------------------------------------OPEN--------
LUE0	push	bc
	push	hl
;
KCOPN0	call	OUSTR
	defw	0a0dh
	defm	'Start tape'
	defb	0
	call	KCET	;Warten auf ET (CY) bzw.^STOP (NC)
	jp	nc,KCER19
;
	pop	de
	call	KCRAM	;HL-> FCB0+9
	ld	a,e
	add	a,27
	ld	e,a
	jr	nc,KCOPN1
	inc	d
KCOPN1	ld	(hl),e
	inc	hl
	ld 	(hl),d	;Adr. fuer 1. Zeichen eintragen
	inc	hl
	ld	(hl),115	;Anzahl vorhandener Zeichen
	inc 	hl
	ld	(hl),1	;LBLNR
	inc	hl	;BLNR
;
KCOPN3	call	KCREAD	;HL unveraendert auf BLNR
	inc	hl
	push	hl
	ld	b,3
	ld	a,0d5h	;Kennzeichen fuer ASCII-BASIC-Datei
KCOPN7	cp	(hl)	;suchen
	inc	hl
	jr	nz,KCOP15	;nicht gef.
	djnz	KCOPN7
;
	push	hl
	ld	de,AUTSTL
	ld	b,8
KCOPN8	ld	a,(de)	;Name = ?
	cp	(hl)
	jr	nz,KCOP14	;nein
	inc	hl
	inc	de
	djnz	KCOPN8
	call	OUSTR
	defw	0a0dh
	defm	'Found: '
	defb	0
	pop	hl
	ld	b,8
	call	KCOP22
	pop	hl
	pop	bc
	ret
;
KCOP14	pop	hl	
KCOP15	call	OUSTR
	defm	'Skip: '
	defb	0
	pop	hl
	push	hl
	ld	b,11
	call	KCOP22
	pop	hl
	dec	hl
	jr	KCOPN3
;
;
KCOP22	ld	a,(hl)
	cp	20h
	jr	c,KCOP23
	cp	7fh
	jr	c,KCOP24
KCOP23	ld	a,'.'
KCOP24	inc	hl
	rst	18h
	djnz	KCOP22
	call	OUSTR
	defw	0a0dh
	defb	0ah
	defb	0
	ret
;*********************************************************************
;Stack wird von Fehlerroutine neu gestellt
;
KCER19	ld	e,19
	jp	ERRFC+2
;
;====================================================================
KCET	call	RDRIPU	;EI
	cp	3
	ret	z	;^STOP -> NC
	cp	0dh
	jr	nz,KCET
	call	OUSTR
	defw	0a0dh
	defb	0
	scf		;ENTER
	ret
;
;====================================================================
KCRAM	ld	a,l
	add	a,9
	ld	l,a
	jr	nc,KCRAM1
	inc	h
KCRAM1	ret
;=====================================================================
;Einlesen eines Blockes vom KMBG
;
KCREAD	call	KCRRAN
	ei
	ret	nc
	push	hl
	ld	hl,RNOTF ;a=1
	dec	a
	jr	z,KCREA1
;
	ld	hl,BADER ;a=2
	dec	a
	jp	nz,KCER19
;
KCREA1	call	OUST1
	pop	hl
	call	KCET	;ET ?
	jr	c,KCREAD	; ja
	jp	KCER19	;^STOP
;=======================================
RNOTF	defb	7		;A=1
	defw	0a0dh
	defm	'Record not found'
	defb	0
BADER	defb	7		;A=3
	defw	0a0dh
	defm	'Bad error'
	defb	0
;=======================================
KCRRAN	push	hl
	ld	a,1
	call	MOTST
	call	MAREK
	pop	hl
	ret	c	;Fehler	
;
	ld	a,(hl)	;BLNR
	dec	hl	;LBLNR
	cp	(hl)
	ld	a,(hl)
	inc	hl
	jr	c,KCRRAN	;noch nicht gefunden
	ret	z	;gef.
;
	dec	a
	jr	z,KCRRAN	;(LBLNR)=1
	ld	a,1	;RNOTF
	scf
	ret
;=======================================================INPUT#=========
LUE1	push	hl
	push	de
	push	bc
KCINP0	call	KCRAM
KCINP6	push	hl	;FCB0+9
	pop	de
	inc	de
	inc	de
	ld	a,(de)	;Anzahl
	or	a
	jr	z,KCINP2	;=0 -> neuen Block einlesen
;
	dec	a
	ld	(de),a	;-1
	ld	e,(hl)	;DE=Adr. fuer Zeichen
	inc	(hl)
	inc	hl
	ld	d,(hl)
	jr	nz,KCINP1
	inc	(hl)	;Adr. fuer naechstes Zeichen
KCINP1	ld	a,(de)	;Zeichen
	cp	3	;EOF ?
	jr	z,KCINPE	; ja
	or	a	;0 ?
	dec	hl	;FCB0+9
	jr	z,KCINP6	; ja
	jr	KCINP5
;------------------------------
;
KCINPE	ld	a,1ah	;EOF beim BIC
	scf
KCINP5	pop	bc
	pop	de
	pop	hl
	ret
;------------------------------
;
KCINP2	ld	d,h
	ld	a,5
	add	a,l
	ld	e,a
	jr	nc,KCINP3
	inc	d
KCINP3	ld	(hl),e
	inc	hl
	ld	(hl),d	;Zeiger auf Bufferanfang
	inc	hl
	ld	(hl),128	;(ANZAHL):=128
	inc	hl
	inc	(hl)	;(LBLNR)+:=1
	inc	hl	;BLNR
	call	KCREAD	;HL unveraendert
	call	OUSTR
	defb	20h	;Space nach jedem Block
	defb	0
	or	a
	ld	de,4
	sbc	hl,de	;hl -> PTR
	jr	KCINP6
;------------------------------------------------------------MAREK-----
MAREK	di
MAREK1	call	DSTPTS
	jr	c,RRER
MAREK2	in	a,(DPIOB)
	rlca
	jr	c,MAREK1
;
	ld	e,0	;bei LOW beginnend
	ld	c,81
MAREK3	ld 	b,22	;Vortoene suchen
MAREK5	ld	d,c
	call	WAITF
	call	WTF10
	call	DSTPTS
	jr	c,RRER
;
	ld	a,c
	cp	62
	jr	c,MAREK3	;0 - Bit
	cp	105
	jr	nc,MAREK3	;TZ
	sub	d
	jr	nc,MAREK4
	neg
MAREK4	cp	7	;im Toleranzbereich ?
	jr	nc,MAREK3	;nein
	djnz	MAREK5
;
	ex	af,af'
	xor	a	;PSUM
	ex	af,af'
;
	call	TRENN
	ret	c
	ld	(hl),a
	inc	hl
	ld	b,128
MAREK6	call	TRENN	;TZ + 8 Bit
	ret	c
	ld	(hl),a
	ex	af,af'
	add	a,(hl)
	ex	af,af'
	inc	hl
	djnz	MAREK6
;
	call	TRENN
	ret	c
	ld	b,a
	ex	af,af'	;PSUM
	cp	b
	ret	z
	scf
	ld	a,2	;Bad error
	ret
;
RRER	ld	a,3
	ret
;=====================================================================
;WAITF - eine Periode auszaehlen
;WTF10 - 1/2      -#-
;-------------------------------
WAITF	ld	c,0
WTF10	inc	c
	jr	z,WTF20
	in	a,(DPIOB)
	xor	e
	jp	p,WTF10
	ld	a,e
	cpl
	ld	e,a
	ret
;
WTF20	dec	c
	ret
;=====================================================================
;Einlesen eines Bytes vom KMBG
;TZ:     130 <= C <= 255
;1 - Bit: 62 <= C <= 114
;0 - Bit: 15 <= C <= 61
;-----------------------------
;
TRENN	push	bc
	ld	c,39
TREN1	ld	b,c
	call	WAITF	;TZ vom vorherigen Byte
	ld	a,b	;abwarten
	add	a,c
	jr	c,TREN1	;zu gross
	cp	130
	jr	c,TREN1	;zu klein
;
	ld	b,8
INBIT	call	WAITF	;eine Periode
	call	WTF10	;auszaehlen -> C
	ld	a,c
	cp	115
	jr	nc,FEHL
	cp	62
	jr	nc,BIT1
	cp	15
	jr	c,FEHL
	scf
BIT1	ccf
	rr	d
	djnz	INBIT
	ld	a,d
	or	a	;NC
	jr	TREND
;
FEHL	ld	a,2	;Bad error
	scf
TREND	pop	bc
	ret
;=====================================================================
;Ausgabe des Strings, dessen Anfangsadresse im Stack steht
;
OUSTR	ex	(sp),hl
	call	OUST1
	ex	(sp),hl
	ret
;----------------------------------------
;Stringausgabe ab HL bis 00
;
OUST1	ex	de,hl
	ld	hl,(ACTFCB)
	push	hl
	ld	hl,0
	ld	(ACTFCB),hl
	ex	de,hl
OUST2	ld	a,(hl)
	inc	hl
	or	a
	jr	z,OUST3
;
	rst	18h
	jr	OUST2
OUST3	ex	(sp),hl
	ld	(ACTFCB),hl
	pop	hl
	ret
;*********************************************************************
ENDE	equ	$
	org	4300h
	di	
	push	hl
	push	de
	push	bc
	push	af
	in	a,(PPIA)
	push	af
	and	0f3h
	or	8
	out	(PPIA),a	;slot 2/ seite 2
	ld	hl,0a000h
	ld	de,4000h
	ld	bc,ENDE-4000h
	ldir
	ld	a,40h
	ld	(SUBBST+9),a
	pop	af
	out	(PPIA),a
	pop	af
	pop	bc
	pop	de
	pop	hl
	ei
	ret
ENDE2	org	4380h
	di
	push	hl
	push	de
	push	bc
	push	af
	in	a,(PPIA)
	push	af
	and	0f3h
	or	8
	out	(PPIA),a
	ld	hl,4000h
	ld	de,0a000h
	ld	bc,ENDE2-4000h
	ldir
	pop	af
	out	(PPIA),a
	pop	af
	pop	bc
	pop	de
	pop	hl
	ei
	ret
;*******************************
	end
